<?php

namespace App\Http\Middleware;

use App\Service\EmployeeService;
use App\Service\JRFIDServerService;
use Closure;

class CheckJRFIDLogin
{
    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure  $next
     * @return mixed
     */
    public function handle($request, Closure $next)
    {
        $token = $request->header('Authorization');
        if(empty($token)) return response()->json(['code'=>401,'msg'=>'缺少登录凭证','data'=>null]);
        if(strpos($token, "Bearer ") === false) $token = "Bearer " . $token;
        $data['token'] = $token;
        $data['header'] = ["Authorization: {$token}",'Content-Type:application/json'];

        $request->common_param = $data;
        return $next($request);
    }
}
