<?php

use Illuminate\Http\Request;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

Route::middleware('auth:api')->get('/user', function (Request $request) {
    return $request->user();
});

Route::any('login', 'Api\LoginController@assetlogin');

Route::group(['middleware'=> ['CheckAssetLogin']],function ($route){
    $route->any('inventoryList', 'Api\AssetController@pdList');
    $route->any('inventoryDetail', 'Api\AssetController@pdDetail');
    $route->any('inventoryUpdate', 'Api\AssetController@pdUpdate');
    $route->any('createFixedBorrow', 'Api\AssetController@createFixedBorrow');
    $route->any('baseFixedQuery', 'Api\AssetController@baseFixedQuery');
    $route->any('createFixedReturn', 'Api\AssetController@createFixedReturn');
    $route->any('manList', 'Api\AssetController@manList');
    $route->any('bmList', 'Api\AssetController@bmList');
    $route->any('fbList', 'Api\AssetController@fbList');
    $route->any('tourismBaseFixedBorrowList', 'Api\AssetController@tourismBaseFixedBorrowList');
});
